de.caff.generics.function

## Interface DoubleOperator1

- All Superinterfaces:
    java.util.function.DoubleUnaryOperator
  Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface DoubleOperator1
      extends java.util.function.DoubleUnaryOperator

  Unary operator with a double argument and result.
  Since:
    October 31, 2019
  Author:
    Rammi

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static DoubleOperator1` | `CUBIC` Cubic function.
    `static DoubleOperator1` | `CUBIC_ROOT` Cubic root function.
    `static DoubleOperator1` | `IDENT` Identity function.
    `static DoubleOperator1` | `NEGATE` Standard NEGATE operator (`-`).
    `static DoubleOperator1` | `SQUARE` Square function.
    `static DoubleOperator1` | `SQUARE_ROOT` Square root function.

  - ### Method Summary

    All Methods Static Methods Instance Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default DoubleOperator1` | `andThen(DoubleOperator1 after)` Create a function which applies this function and feeds the result into the next function.
    `static DoubleOperator1` | `from(java.util.function.DoubleUnaryOperator operator)` Make a standard unary double operator usable as `DoubleOperator1`.
    `default DoubleOperator0` | `partial(double argument)` Create a zero argument function from this one by applying a constant argument.

    - ### Methods inherited from interface java.util.function.DoubleUnaryOperator

      `andThen, applyAsDouble, compose, identity`

- - ### Field Detail

    - #### NEGATE

          static final DoubleOperator1 NEGATE

      Standard NEGATE operator (`-`).

    - #### IDENT

          static final DoubleOperator1 IDENT

      Identity function. This returns the argument.

    - #### SQUARE

          static final DoubleOperator1 SQUARE

      Square function. This returns the square of the argument.

    - #### CUBIC

          static final DoubleOperator1 CUBIC

      Cubic function. This returns the third power of the argument.

    - #### SQUARE_ROOT

          static final DoubleOperator1 SQUARE_ROOT

      Square root function. This returns the square root of the argument.

    - #### CUBIC_ROOT

          static final DoubleOperator1 CUBIC_ROOT

      Cubic root function. This returns the cubic root of the argument.

  - ### Method Detail

    - #### partial

          @NotNull
          default DoubleOperator0 partial(double argument)

      Create a zero argument function from this one by applying a constant argument. Although useless for pure functions it can be useful in cases where the zero argument function is a factory (and therefore not pure).
      Parameters:
        `argument` - constant argument
      Returns:
        zero argument function

    - #### andThen

          @NotNull
          default DoubleOperator1 andThen(@NotNull
                                                   DoubleOperator1 after)

      Create a function which applies this function and feeds the result into the next function.
      Parameters:
        `after` - function called with the result of this function
      Returns:
        chained function

    - #### from

          @NotNull
          static DoubleOperator1 from(@NotNull
                                               java.util.function.DoubleUnaryOperator operator)

      Make a standard unary double operator usable as `DoubleOperator1`. This is useful if you want to make use of the extended functionality of this implementation.
      Parameters:
        `operator` - operator to be used as a `DoubleOperator1`
      Returns:
        `DoubleOperator1` view of the incoming operator, or possibly just a cast if `operator` already has the correct type